
class Node:
    def __init__(self, data, left, right):
        self.data = data
        self.left = left
        self.right = right

def create_tree():
    """Returns root node of the tree from slides."""
    n4 = Node(4, None, None)
    n3 = Node(3, None, n4)
    n2 = Node(2, n3, None)
    n9 = Node(9, None, None)
    n8 = Node(8, None, n9)
    n7 = Node(7, None, None)
    n6 = Node(6, n7, n8)
    n1 = Node(1, n2, n6)
    return n1

def create_tree_v2():
    """Returns root node of the tree from slides."""
    return Node(
        1, 
        Node(
            2, 
            Node(3, None, Node(4, None, None)), 
            None), 
        Node(
            6, 
            Node(7, None, None), 
            Node(8, None, Node(9, None, None))))


class Prvek:
    def __init__(self, hodnota, dalsi):
        self.hodnota = hodnota
        self.dalsi = dalsi
p = Prvek(1, Prvek(2,Prvek(3,None)))


def vypis_po_hladinach(tree):
    fronta = [tree]
    while len(fronta) > 0:
        # zpracuj prvni
        p = fronta[0]
        #vypis
        print(p.data, end=",")
        #odstran
        del fronta[0]
        #pridej nasledniky
        if p.left:
            fronta.append(p.left)
        if p.right:
            fronta.append(p.right)

def vypis_po_hladinach2(tree):
    fronta = [(tree,0)]
    while len(fronta) > 0:
        # zpracuj prvni
        p, hladina = fronta[0]
        #vypis
        print(f"({p.data},{hladina})", end=",")
        #odstran
        del fronta[0]
        #pridej nasledniky
        if p.left:
            fronta.append((p.left, hladina+1))
        if p.right:
            fronta.append((p.right, hladina+1))

if __name__ == "__main__":
    tree = create_tree_v2()
    vypis_po_hladinach2(tree)
    





